/*
 * This is a part of PolyORB-HI-C distribution, a minimal
 * middleware written for generated code from AADL models.
 * You should use it with the Ocarina toolsuite.
 *
 * For more informations, please visit http://www.openaadl.org
 *
 * Copyright (C) 2020 OpenAADL
 */

#if (defined (__PO_HI_NEED_DRIVER_SOCKETS) || defined (__PO_HI_NEED_DRIVER_RTEMS_NE2000_SOCKETS))\n
/*
Code automatically generated by asn1scc tool
*/
#include <limits.h>
#include <string.h>
#include <math.h>


#include "ip.h"

const __po_hi_c_ip_conf_t localhost1 = {
    .devname = "eth0",
    .address = "127.0.0.1",
    .version = __po_hi_c_ipv4,
    .port = 5488,
    .exist = {
        .broadcast = 0,
        .netmask = 0,
        .gateway = 0,
        .dns = 0,
        .version = 0
    }
};
const __po_hi_c_ip_conf_t localhost2 = {
    .devname = "eth0",
    .address = "127.0.0.1",
    .version = __po_hi_c_ipv4,
    .port = 5489,
    .exist = {
        .broadcast = 0,
        .netmask = 0,
        .gateway = 0,
        .dns = 0,
        .version = 0
    }
};


void __po_hi_c_Port_T_Initialize(__po_hi_c_Port_T* pVal)
{
	(void)pVal;


	(*(pVal)) = 0;
}

flag __po_hi_c_Port_T_IsConstraintValid(const __po_hi_c_Port_T* pVal, int* pErrCode)
{
    flag ret = TRUE;
	(void)pVal;
	
    ret = ((*(pVal)) <= 16535UL);
    *pErrCode = ret ? 0 :  ERR_PORT_T; 

	return ret;
}



void __po_hi_c_Version_T_Initialize(__po_hi_c_Version_T* pVal)
{
	(void)pVal;


	(*(pVal)) = __po_hi_c_ipv4;
}

flag __po_hi_c_Version_T_IsConstraintValid(const __po_hi_c_Version_T* pVal, int* pErrCode)
{
    flag ret = TRUE;
	(void)pVal;
	
    ret = ((((*(pVal)) == __po_hi_c_ipv4)) || (((*(pVal)) == __po_hi_c_ipv6)));
    *pErrCode = ret ? 0 :  ERR_VERSION_T; 

	return ret;
}



void __po_hi_c_ip_conf_t_devname_Initialize(__po_hi_c_ip_conf_t_devname val)
{
	(void)val;


	memset(val, 0x0, 21);

}
void __po_hi_c_ip_conf_t_address_Initialize(__po_hi_c_ip_conf_t_address val)
{
	(void)val;


	memset(val, 0x0, 41);

}
void __po_hi_c_ip_conf_t_broadcast_Initialize(__po_hi_c_ip_conf_t_broadcast val)
{
	(void)val;


	memset(val, 0x0, 41);

}
void __po_hi_c_ip_conf_t_netmask_Initialize(__po_hi_c_ip_conf_t_netmask val)
{
	(void)val;


	memset(val, 0x0, 41);

}
void __po_hi_c_ip_conf_t_gateway_Initialize(__po_hi_c_ip_conf_t_gateway val)
{
	(void)val;


	memset(val, 0x0, 41);

}
void __po_hi_c_ip_conf_t_dns_Initialize(__po_hi_c_ip_conf_t_dns val)
{
	(void)val;


	memset(val, 0x0, 41);

}
void __po_hi_c_ip_conf_t_Initialize(__po_hi_c_ip_conf_t* pVal)
{
	(void)pVal;



	/*set devname */
	__po_hi_c_ip_conf_t_devname_Initialize(pVal->devname);
	/*set address */
	__po_hi_c_ip_conf_t_address_Initialize(pVal->address);
	/*set broadcast */
	pVal->exist.broadcast = 1;
	__po_hi_c_ip_conf_t_broadcast_Initialize(pVal->broadcast);
	/*set netmask */
	pVal->exist.netmask = 1;
	__po_hi_c_ip_conf_t_netmask_Initialize(pVal->netmask);
	/*set gateway */
	pVal->exist.gateway = 1;
	__po_hi_c_ip_conf_t_gateway_Initialize(pVal->gateway);
	/*set dns */
	pVal->exist.dns = 1;
	__po_hi_c_ip_conf_t_dns_Initialize(pVal->dns);
	/*set version */
	pVal->exist.version = 1;
	pVal->version = __po_hi_c_ipv4;
	/*set port */
	__po_hi_c_Port_T_Initialize((&(pVal->port)));
}

flag __po_hi_c_ip_conf_t_IsConstraintValid(const __po_hi_c_ip_conf_t* pVal, int* pErrCode)
{
    flag ret = TRUE;
	(void)pVal;
	
    ret = ((1 <= strlen(pVal->devname)) && (strlen(pVal->devname) <= 20));
    *pErrCode = ret ? 0 :  ERR_IP_CONF_T_DEVNAME; 
    if (ret) {
        ret = ((1 <= strlen(pVal->address)) && (strlen(pVal->address) <= 40));
        *pErrCode = ret ? 0 :  ERR_IP_CONF_T_ADDRESS; 
        if (ret) {
            if (pVal->exist.broadcast) {
            	ret = ((1 <= strlen(pVal->broadcast)) && (strlen(pVal->broadcast) <= 40));
            	*pErrCode = ret ? 0 :  ERR_IP_CONF_T_BROADCAST; 
            }
            if (ret) {
                if (pVal->exist.netmask) {
                	ret = ((1 <= strlen(pVal->netmask)) && (strlen(pVal->netmask) <= 40));
                	*pErrCode = ret ? 0 :  ERR_IP_CONF_T_NETMASK; 
                }
                if (ret) {
                    if (pVal->exist.gateway) {
                    	ret = ((1 <= strlen(pVal->gateway)) && (strlen(pVal->gateway) <= 40));
                    	*pErrCode = ret ? 0 :  ERR_IP_CONF_T_GATEWAY; 
                    }
                    if (ret) {
                        if (pVal->exist.dns) {
                        	ret = ((1 <= strlen(pVal->dns)) && (strlen(pVal->dns) <= 40));
                        	*pErrCode = ret ? 0 :  ERR_IP_CONF_T_DNS; 
                        }
                        if (ret) {
                            if (pVal->exist.version) {
                            	ret = (((pVal->version == __po_hi_c_ipv4)) || ((pVal->version == __po_hi_c_ipv6)));
                            	*pErrCode = ret ? 0 :  ERR_IP_CONF_T_VERSION; 
                            }
                            if (ret) {
                                ret = (pVal->port <= 16535UL);
                                *pErrCode = ret ? 0 :  ERR_IP_CONF_T_PORT; 
                            }
                        }
                    }
                }
            }
        }
    }

	return ret;
}

\n#endif
